org.apache.storm.topology

## Interface InputDeclarer<T extends InputDeclarer>

- All Known Subinterfaces:
    BoltDeclarer
  All Known Implementing Classes:
    TopologyBuilder.BoltGetter

      public interface InputDeclarer<T extends InputDeclarer>

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `T` | `allGrouping(String componentId)` The stream is replicated across all the bolt’s tasks.
    `T` | `allGrouping(String componentId, String streamId)` The stream is replicated across all the bolt’s tasks.
    `T` | `customGrouping(String componentId, CustomStreamGrouping grouping)` A custom stream grouping by implementing the CustomStreamGrouping interface.
    `T` | `customGrouping(String componentId, String streamId, CustomStreamGrouping grouping)` A custom stream grouping by implementing the CustomStreamGrouping interface.
    `T` | `directGrouping(String componentId)` A stream grouped this way means that the producer of the tuple decides which task of the consumer will receive this tuple.
    `T` | `directGrouping(String componentId, String streamId)` A stream grouped this way means that the producer of the tuple decides which task of the consumer will receive this tuple.
    `T` | `fieldsGrouping(String componentId, Fields fields)` The stream is partitioned by the fields specified in the grouping.
    `T` | `fieldsGrouping(String componentId, String streamId, Fields fields)` The stream is partitioned by the fields specified in the grouping.
    `T` | `globalGrouping(String componentId)` The entire stream goes to a single one of the bolt’s tasks.
    `T` | `globalGrouping(String componentId, String streamId)` The entire stream goes to a single one of the bolt’s tasks.
    `T` | `grouping(GlobalStreamId id, Grouping grouping)`
    `T` | `localOrShuffleGrouping(String componentId)` If the target bolt has one or more tasks in the same worker process, tuples will be shuffled to just those in-process tasks.
    `T` | `localOrShuffleGrouping(String componentId, String streamId)` If the target bolt has one or more tasks in the same worker process, tuples will be shuffled to just those in-process tasks.
    `T` | `noneGrouping(String componentId)` This grouping specifies that you don’t care how the stream is grouped.
    `T` | `noneGrouping(String componentId, String streamId)` This grouping specifies that you don’t care how the stream is grouped.
    `T` | `partialKeyGrouping(String componentId, Fields fields)` Tuples are passed to two hashing functions and each target task is decided based on the comparison of the state of candidate nodes.
    `T` | `partialKeyGrouping(String componentId, String streamId, Fields fields)` Tuples are passed to two hashing functions and each target task is decided based on the comparison of the state of candidate nodes.
    `T` | `shuffleGrouping(String componentId)` Tuples are randomly distributed across the bolt’s tasks in a way such that each bolt is guaranteed to get an equal number of tuples.
    `T` | `shuffleGrouping(String componentId, String streamId)` Tuples are randomly distributed across the bolt’s tasks in a way such that each bolt is guaranteed to get an equal number of tuples.

- - ### Method Detail

    - #### fieldsGrouping

          T fieldsGrouping(String componentId,
                           Fields fields)

      The stream is partitioned by the fields specified in the grouping.

    - #### fieldsGrouping

          T fieldsGrouping(String componentId,
                           String streamId,
                           Fields fields)

      The stream is partitioned by the fields specified in the grouping.

    - #### globalGrouping

          T globalGrouping(String componentId)

      The entire stream goes to a single one of the bolt’s tasks. Specifically, it goes to the task with the lowest id.

    - #### globalGrouping

          T globalGrouping(String componentId,
                           String streamId)

      The entire stream goes to a single one of the bolt’s tasks. Specifically, it goes to the task with the lowest id.

    - #### shuffleGrouping

          T shuffleGrouping(String componentId)

      Tuples are randomly distributed across the bolt’s tasks in a way such that each bolt is guaranteed to get an equal number of tuples.

    - #### shuffleGrouping

          T shuffleGrouping(String componentId,
                            String streamId)

      Tuples are randomly distributed across the bolt’s tasks in a way such that each bolt is guaranteed to get an equal number of tuples.

    - #### localOrShuffleGrouping

          T localOrShuffleGrouping(String componentId)

      If the target bolt has one or more tasks in the same worker process, tuples will be shuffled to just those in-process tasks. Otherwise, this acts like a normal shuffle grouping.

    - #### localOrShuffleGrouping

          T localOrShuffleGrouping(String componentId,
                                   String streamId)

      If the target bolt has one or more tasks in the same worker process, tuples will be shuffled to just those in-process tasks. Otherwise, this acts like a normal shuffle grouping.

    - #### noneGrouping

          T noneGrouping(String componentId)

      This grouping specifies that you don’t care how the stream is grouped.

    - #### noneGrouping

          T noneGrouping(String componentId,
                         String streamId)

      This grouping specifies that you don’t care how the stream is grouped.

    - #### allGrouping

          T allGrouping(String componentId)

      The stream is replicated across all the bolt’s tasks. Use this grouping with care.

    - #### allGrouping

          T allGrouping(String componentId,
                        String streamId)

      The stream is replicated across all the bolt’s tasks. Use this grouping with care.

    - #### directGrouping

          T directGrouping(String componentId)

      A stream grouped this way means that the producer of the tuple decides which task of the consumer will receive this tuple.

    - #### directGrouping

          T directGrouping(String componentId,
                           String streamId)

      A stream grouped this way means that the producer of the tuple decides which task of the consumer will receive this tuple.

    - #### partialKeyGrouping

          T partialKeyGrouping(String componentId,
                               Fields fields)

      Tuples are passed to two hashing functions and each target task is decided based on the comparison of the state of candidate nodes.

      See https://melmeric.files.wordpress.com/2014/11/the-power-of-both-choices-practical-load-balancing-for-distributed-stream -processing-engines.pdf

    - #### partialKeyGrouping

          T partialKeyGrouping(String componentId,
                               String streamId,
                               Fields fields)

      Tuples are passed to two hashing functions and each target task is decided based on the comparison of the state of candidate nodes.

      See https://melmeric.files.wordpress.com/2014/11/the-power-of-both-choices-practical-load-balancing-for-distributed-stream -processing-engines.pdf

    - #### customGrouping

          T customGrouping(String componentId,
                           CustomStreamGrouping grouping)

      A custom stream grouping by implementing the CustomStreamGrouping interface.

    - #### customGrouping

          T customGrouping(String componentId,
                           String streamId,
                           CustomStreamGrouping grouping)

      A custom stream grouping by implementing the CustomStreamGrouping interface.

    - #### grouping

          T grouping(GlobalStreamId id,
                     Grouping grouping)

Copyright © 2021 The Apache Software Foundation. All rights reserved.